#include <bits/stdc++.h>
using namespace std;

using ll = long long;

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("lzcnt,avx2")

constexpr ll INF = 3e18;


struct rect {
    int l, r, h, c;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n >> m;

    ll ans = m;

    rect a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i].l >> a[i].r >> a[i].h >> a[i].c;
        ans += a[i].h * 2;
    }

    ll pref[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i].c; 
    }

    ll dp[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        dp[i] = INF;
        ll r = i - 1;
        for (int j = i; j >= 1; j--) {
            ll here = dp[j - 1];
            ll cur = 0;
            for (int k = j; k < i; k++) {
                cur += (pref[i] - pref[k]) * (a[k + 1].l - a[k].r);
                here -= min(a[k + 1].h, a[k].h) * 2;
            }

            ll best = cur;
            ll besti = j - 1;
            for (int k = j; k <= r; k++) {
                cur -= (pref[i] - pref[k]) * (a[k + 1].l - a[k].r);
                cur += (pref[k] - pref[j - 1]) * (a[k + 1].l - a[k].r);
                if (cur < best) {
                    best = cur;
                    besti = k;
                }
            }
            r = besti;

            dp[i] = min(dp[i], here + best);
        }
    }

    printf("%lld\n", ans + dp[n]);

    
}
