#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll tmp[1000][2];
ll dp[500001][2];
ll l[500001];
ll r[500001];
ll h[500001];
ll c[500001];
ll pref_space[500001];
ll pref_cost[500001];
ll pref_dh[500001];
ll pref_move[500001];

ll suf_space[500001];
ll suf_cost[500001];
ll suf_move[500001];
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
struct li_chao {
    struct line {
        ll k,b;
        line(ll _k,ll _b) {
            k = _k;
            b = _b;
        }
        ll eval(ll x) {
            return k*x+b;
        }
    };
    struct node {
        node* ls, * rs;
        line v;
    };
    node* root;
    void update(node*&v,ll l ,ll r,line L) {
        if(v == nullptr) {
            v = new node({0,0,L});
            return;
        }
        int m = (l+r)/2;
        bool mid = L.eval(m) < v->v.eval(m);
        bool left = L.eval(l) < v->v.eval(l);
        if(mid) swap(v->v,L);
        if(l == r) return;
        if(left != mid) {
            if(!v->ls) v->ls = new node({0,0,L});
            else update(v->ls,l,m,L);
        }
        else {
            if(!v->rs) v->rs = new node({0,0,L});
            else update(v->rs,m+1,r,L);
        }
    }
    void update(line L) {
        // cerr << "update " << L.k << " " << L.b << "\n";
        update(root,0,1e18,L);
    }
    ll query(node*v,ll l,ll r,ll x) {
        if(!v) return 1e18;
        if(l == r) return v->v.eval(x);
        ll m = (l+r)/2;
        if(x <= m) return min(v->v.eval(x),query(v->ls,l,m,x));
        return min(v->v.eval(x),query(v->rs,m+1,r,x));
    }
    ll query(ll x) {
        // cerr << "query " << x << " " << query(root,0,1e18,x) << "\n";
        return query(root,0,1e18,x);
    }
    li_chao() {
        root = nullptr;
    }
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin >> n >> m;

    for(int i = 0;i < n;i++) {
        cin >> l[i] >> r[i] >> h[i] >> c[i];

        pref_cost[i] = c[i];
        if(i) pref_cost[i] += pref_cost[i-1];
        pref_space[i] = 0;
        if(i) pref_space[i] = pref_space[i-1]+l[i]-r[i-1];
        if(i) pref_dh[i] = pref_dh[i-1]+ abs((h[i]-h[i-1]));
        pref_move[i] = 0;
        if(i) pref_move[i] = pref_move[i-1]+c[i]*pref_space[i];
    }
    for(int i = n-1;i >= 0;i--) {
        suf_cost[i] = c[i];
        if(i < n-1) suf_cost[i] += suf_cost[i+1];
        suf_space[i] = 0;
        if(i < n-1) suf_space[i] = suf_space[i+1]+l[i+1]-r[i];
        suf_move[i] = 0;
        if(i < n-1) suf_move[i] = suf_move[i+1]+c[i]*suf_space[i];
    }
    for(int i = 0;i < n;i++) {
        for(int j = 0;j < 2;j++) {
            dp[i][j] = 5e18;
        }
    }
    dp[0][0] = 2*h[0];
    dp[0][1] = 2*h[0];
    li_chao move,not_move;
    move.update({-pref_space[0],dp[0][0]-h[0]-pref_dh[0]-pref_move[0]});
    not_move.update({-suf_cost[0],-pref_dh[0]+h[0]+suf_move[0]});
    for (int i = 1; i < n;i++) {
        // not move
        dp[i][0] = min(dp[i][0],min(dp[i-1][0],dp[i-1][1]) + 2*h[i]);
        ll delta = h[i]+pref_dh[i]-suf_move[i]+suf_space[i]*suf_cost[i];
        delta += not_move.query(suf_space[i]);
        dp[i][0] = min(dp[i][0],delta);
        dp[i][1] = min(dp[i][1],dp[i][0]);
        delta = h[i]+pref_dh[i]+pref_move[i];
        delta += move.query(pref_space[i]);
        dp[i][1] = min(dp[i][1],delta);
        not_move.update({-suf_cost[i],dp[i-1][1]-pref_dh[i]+h[i]+suf_move[i]});
        move.update({-pref_space[i],dp[i][0]-h[i]-pref_dh[i]-pref_move[i]+pref_space[i]*pref_cost[i]});
    }
    // for (int i = 0; i < n; i++) {
    //   cout << dp[i][0] << " " << dp[i][1] << "\n";
    // }
    cout << min(dp[n-1][0],dp[n-1][1])+m << "\n";
}
/*
2 0
8 14 10 1
59 60 62 1
*/