#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

vector< pair<ll, ll> > v;
vector<ll> G[200000];

void solve1() {
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        ll l = -1, r = (y - x + 1);
        while (r > l) {
            ll mid = r - (r - l) / 2;
            for (int i = x; i <= y; i++) {
                if (v[i].first <= mid) {
                    G[v[i].first].push_back(v[i].second);
                }
                if (v[i].second <= mid) {
                    G[v[i].second].push_back(v[i].first);
                }
            }
            unordered_set<ll> discard;
            bool fl = 1;
            for (int i = 0; i <= mid; i++) {
                if (!discard.count(i)) {
                    bool fl1 = 0;
                    queue<ll> q;
                    q.push(i);
                    unordered_set<ll> st;
                    st.insert(i);
                    while (!q.empty()) {
                        ll x = q.front();
                        q.pop();
                        for (int j : G[x]) {
                            if (!st.count(j)) {
                                if (j <= mid) {
                                    st.insert(j);
                                    q.push(j);
                                }
                                else {
                                    fl1 = 1;
                                }
                            }
                            else if (!discard.count(j)) {
                                fl1 = 1;
                            }
                        }
                        discard.insert(x);
                    }
                    fl = (fl && fl1);
                }
            }
            for (int i = 0; i <= mid; i++) {
                G[i].clear();
            }
            if (fl) {
                l = mid;
            }
            else {
                r = mid - 1;
            }
        }
        cout << l + 1 << '\n';
    }
}

void solve01() {
    vector< array<ll, 2> > pr(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i];
        pr[i + 1][v[i].first]++;
        pr[i + 1][v[i].second]++;
    }
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        if ((y - x) >= 1 && pr[y + 1][0] - pr[x][0] >= 1 && pr[y + 1][1] - pr[x][1] >= 1) {
            cout << 2 << '\n';
        }
        else if (pr[y + 1][0] - pr[x][0] >= 1) {
            cout << 1 << '\n';
        }
        else {
            cout << 0 << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    v.resize(n);
    ll mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        mx = max(mx, v[i].first);
    }
    for (int i = 0; i < n; i++) {
        cin >> v[i].second;
        mx = max(mx, v[i].second);
    }
    cin >> q;
    if (q == 1) {
        solve1();
    }
    else if (mx <= 1) {
        solve01();
    }
}
