#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")

using namespace std;
using ll = int;

constexpr ll INF = 1000000000LL;

ll n, m, q, k, x, y, a, b, c;

vector< pair<ll, ll> > v;
vector<ll> G[200000];

void solve1() {
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        ll r = (y - x);
        for (int i = x; i <= y; i++) {
            if (v[i].first <= (y - x + 1)) {
                G[v[i].first].push_back(v[i].second);
            }
            if (v[i].second <= (y - x + 1)) {
                G[v[i].second].push_back(v[i].first);
            }
        }
        unordered_set<ll> discard;
        for (int i = 0; i <= (y - x + 1); i++) {
            if (!discard.count(i)) {
                ll mx = -INF;
                bool fl1 = 0;
                queue<ll> q;
                q.push(i);
                unordered_set<ll> st;
                st.insert(i);
                while (!q.empty()) {
                    ll x = q.front();
                    q.pop();
                    for (int j : G[x]) {
                        if (!st.count(j)) {
                            if (j <= (y - x + 1)) {
                                st.insert(j);
                                q.push(j);
                            }
                            else {
                                fl1 = 1;
                                break;
                            }
                        }
                        else if (!discard.count(j)) {
                            fl1 = 1;
                            break;
                        }
                    }
                    mx = max(mx, x);
                    discard.insert(x);
                    if (fl1) {
                        break;
                    }
                }
                if (!fl1) {
                    r = min(r, mx - 1);
                }
            }
        }
        for (int i = 0; i <= (y - x + 1); i++) {
            G[i].clear();
        }
        cout << r + 1 << '\n';
    }
}

void solve01() {
    vector< array<ll, 2> > pr(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i];
        pr[i + 1][v[i].first]++;
        pr[i + 1][v[i].second]++;
    }
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        if ((y - x) >= 1 && pr[y + 1][0] - pr[x][0] >= 1 && pr[y + 1][1] - pr[x][1] >= 1) {
            cout << 2 << '\n';
        }
        else if (pr[y + 1][0] - pr[x][0] >= 1) {
            cout << 1 << '\n';
        }
        else {
            cout << 0 << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    v.resize(n);
    ll mx = 0;
    bool fl = 1;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        mx = max(mx, v[i].first);
    }
    for (int i = 0; i < n; i++) {
        cin >> v[i].second;
        mx = max(mx, v[i].second);
        if (v[i].first != v[i].second) {
            fl = 0;
        }
    }
    cin >> q;
    if (mx <= 1) {
        solve01();
    }
    else {
        solve1();
    }
}
