#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")

using namespace std;
using ll = int;

constexpr ll INF = 1000000000LL;

ll n, m, q, k, x, y, a, b, c;

vector< pair<ll, ll> > v;
vector<ll> G[200000];

void solve1() {
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        ll r = (y - x);
        for (int i = x; i <= y; i++) {
            if (v[i].first <= (y - x)) {
                G[v[i].first].push_back(v[i].second);
            }
            if (v[i].second <= (y - x)) {
                G[v[i].second].push_back(v[i].first);
            }
        }
        unordered_set<ll> discard;
        for (int i = 0; i <= (y - x); i++) {
            if (!discard.count(i)) {
                // cout << i << '\n';
                ll mx = -INF;
                bool fl1 = 0;
                queue<ll> q;
                q.push(i);
                unordered_set<ll> st;
                st.insert(i);
                while (!q.empty()) {
                    ll x = q.front();
                    q.pop();
                    // cout << '\t' << x << '\n';
                    for (int j : G[x]) {
                        // cout << "\t\t" << j << '\n';
                        if (!st.count(j)) {
                            if (j <= (y - x)) {
                                st.insert(j);
                                q.push(j);
                            }
                            else {
                                fl1 = 1;
                                break;
                            }
                        }
                        else if (!discard.count(j)) {
                            fl1 = 1;
                            break;
                        }
                    }
                    mx = max(mx, x);
                    discard.insert(x);
                    if (fl1) {
                        while (!q.empty()) {
                            ll x = q.front();
                            q.pop();
                            discard.insert(x);
                        }
                        break;
                    }
                }
                if (!fl1) {
                    // cout << "ERROR\n";
                    r = min(r, mx - 1);
                }
            }
        }
        for (int i = 0; i <= (y - x); i++) {
            G[i].clear();
        }
        cout << r + 1 << '\n';
    }
}

void solve01() {
    vector< array<ll, 2> > pr(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i];
        pr[i + 1][v[i].first]++;
        pr[i + 1][v[i].second]++;
    }
    while (q --> 0) {
        cin >> x >> y;
        x--;
        y--;
        if ((y - x) >= 1 && pr[y + 1][0] - pr[x][0] >= 1 && pr[y + 1][1] - pr[x][1] >= 1) {
            cout << 2 << '\n';
        }
        else if (pr[y + 1][0] - pr[x][0] >= 1) {
            cout << 1 << '\n';
        }
        else {
            cout << 0 << '\n';
        }
    }
}

struct segtree {
    ll sz;
    vector<ll> tr;
    segtree(ll SZ) {
        // bit.resize(sz);
        // bit.assign(sz, -1);
        sz = SZ;
        tr.assign(sz * 4, -INF);
    }
    
    void upd(ll x, ll l, ll r, ll idx, ll val) {
        if (l == r) {
            tr[x] = max(tr[x], val);
            return;
        }
        ll mid = (r + l) / 2;
        if (idx <= mid) {
            upd(x * 2 + 1, l, mid, idx, val);
        }
        else {
            upd(x * 2 + 2, mid + 1, r, idx, val);
        }
        tr[x] = min(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    ll query(ll x, ll l, ll r, ll L, ll R) {
        if (l > r) {
            return INF;
        }
        if (L > r) {
            return INF;
        }
        if (l > R) {
            return INF;
        }
        if (L <= l && r <= R) {
            return tr[x];
        }
        ll mid = (r + l) / 2;
        return min(query(x * 2 + 1, l, mid, L, R), query(x * 2 + 2, mid + 1, r, L, R));
    }
};

void solveab() {
    vector< vector< pair<ll,ll> > > vq(n);
    vector<ll> ans(q);
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        vq[y].push_back({x, i});
    }
    segtree f(n + 2);
    for (int i = 0; i < n; i++) {
        f.upd(0, 0, f.sz - 1, v[i].first, i);
        // cout << v[i].first << ' ' << i << '\n';
        for (auto j : vq[i]) {
            // cout << j.first << ' ' << i << ' ' << j.second << '\n';
            ll l = -1, r = n;
            while (r > l) {
                ll mid = r - (r - l) / 2;
                // cout << '\t' << mid << ' ' << f.query(0, 0, f.sz - 1, 0, mid) << '\n';
                if (f.query(0, 0, f.sz - 1, 0, mid) >= j.first) {
                    l = mid;
                }
                else {
                    r = mid - 1;
                }
            } 
            ans[j.second] = l + 1;
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    v.resize(n);
    ll mx = 0;
    bool fl = 1;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        mx = max(mx, v[i].first);
    }
    for (int i = 0; i < n; i++) {
        cin >> v[i].second;
        mx = max(mx, v[i].second);
        if (v[i].first != v[i].second) {
            fl = 0;
        }
    }
    cin >> q;
    if (mx <= 1) {
        solve01();
    }
    else if (fl) {
        solveab();
    }
    else {
        solve1();
    }
}
