#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	int mn = 0;
	vector<int> l(n), h(n), c(n);
	for (int i = 0; i < n; i++) {
		int r;
		cin >> l[i] >> r >> h[i] >> c[i];
		l[i] -= mn;
		mn += r - l[i] - mn;
	}
	vector<vector<ll>> dp(n, vector<ll>(n));
	for (int j = 0; j < n; j++)
		dp[0][j] = abs(l[0] - l[j]) * 1ll * c[0] + h[0];
	for (int i = 1; i < n; i++) {
		ll mnz = 1e18;
		for (int j = 0; j < n; j++) {
			dp[i][j] = min(dp[i - 1][j] + abs(h[i] - h[i - 1]), mnz + h[i] + h[i - 1]) + abs(l[i] - l[j]) * 1ll * c[i];
			mnz = min(mnz, dp[i - 1][j]);
		}
	}
	ll ans = 1e18;
	for (int j = 0; j < n; j++)
		ans = min(ans, dp[n - 1][j]);
	cout << ans + m + h[n - 1] << "\n";
}
