#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
using ll = long long;
const int inf = 2e5 + 5;

struct ST{
    vector<int> t, a;
    int n;
    void build(int v, int tl, int tr){
        if (tl == tr){
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        build(vv, tl, tm);
        build(vv + 1, tm + 1, tr);
        t[v] = min(t[vv], t[vv + 1]);
    }
    ST(vector<int> as){
        a = as;
        n = a.size() - 1;
        t.resize(4 * n);
        build(1, 1, n);
    }
    void upd(int v, int tl, int tr, int& p, int& k){
        if (tl == tr){
            t[v] = k;
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        if (p <= tm){
            upd(vv, tl, tm, p, k);
        }
        else {
            upd(vv + 1, tm + 1, tr, p, k);
        }
        t[v] = min(t[vv], t[vv + 1]);
    }
    void upd(int p, int v){
        upd(1, 1, n, p, v);
    }
    int get(int v, int tl, int tr, int& l, int& r){
        if (l > tr || r < tl) return inf;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2, vv = 2 * v;
        return min(get(vv, tl, tm, l, r), get(vv + 1, tm + 1, tr, l, r));
    }
    int get(int l, int r){
        return get(1, 1, n, l, r);
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n; cin>>n;
    vector<int> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>a[i];
    }
    bool ind = true;
    for (int i = 1; i <= n; i++){
        cin>>b[i];
        if (a[i] != b[i]){
            ind = false;
        }
    }
    if (ind){
        int q; cin>>q;
        vector<pii> end[n + 1];
        for (int i = 1; i <= q; i++){
            int l, r; cin>>l>>r;
            end[r].push_back({l, i});
        }
        vector<int> p(n + 1), out(q + 1), k(2 * n + 2, inf);
        for (int i = 1; i <= n + 1; i++){
            k[i] = i - 1;
            p[i - 1] = i;
        }
        ST T(k);
        for (int i = 1; i <= n; i++){
            T.upd(p[a[i]], inf);
            T.upd(i + n + 1, a[i]);
            p[a[i]] = i + n + 1;
            for (auto [l, j]: end[i]){
                out[j] = T.get(1, n + l);
            }
        }
        for (int i = 1; i <= q; i++){
            cout<<out[i]<<"\n";
        }
        return 0;
    }
}