#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  //freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, l, r, x, y, mn, mx;
  cin >> n;
  vector<ll> original_positions(n);
  vector<ll> time(n);
  for (ll i = 0; i < n; i++) {
    cin >> original_positions[i];
    cin >> time[i];
  }
  a = original_positions[0];
  sort(all(time));
  vector<ll> distances(n);
  for (ll i = 1; i <= n; i++) {
    distances[i - 1] = abs(i - a);
  }
  sort(all(distances), [](ll first, ll second) { return first > second; });
  ll sm = 0;
  for (ll i = 0; i < n; i++) {
    sm = max(sm, time[i] * distances[i]);
  }
  cout << sm;
}
