#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()

struct node {
  ll value;
  node *prev;
  node *next;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  //freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, l, r, x, y, mn, mx;
  cin >> n;
  vector<ll> original_positions(n);
  vector<ll> time(n);
  vector<vector<ll>> pos_children(n + 1);
  for (ll i = 0; i < n; i++) {
    cin >> original_positions[i];
    pos_children[original_positions[i]].push_back(i);
    cin >> time[i];
  }
  node *start_hole = new node();
  start_hole->prev = nullptr;
  node *end_hole = start_hole;
  for (ll i = 1; i <= n; i++) {
    if (pos_children[i].empty()) {
      node *new_hole = new node();
      new_hole->prev = end_hole;
      new_hole->value = -1;
      end_hole->value = i;
      end_hole->next = new_hole;
      end_hole = new_hole;
    }
  }
  if (end_hole->value == -1) {
    end_hole->prev->next = nullptr;
  }
  a = original_positions[0];
  sort(all(time));
  ll sm = 0;
  for (ll i = 1; i <= n; i++) {
    for (ll j = 0; j + 1 < pos_children[i].size(); j++) {
      mn = abs(start_hole->value - i);
      node *mn_node = start_hole;
      node *curr_node = start_hole;
      while (curr_node->next != nullptr) {
        curr_node = curr_node->next;
        d = abs(curr_node->value - i);
        if (d < mn) {
          mn = d;
          mn_node = curr_node;
        }
      }
      if (mn_node->prev == nullptr)
        start_hole = mn_node->next;
      else
        mn_node->prev->next = mn_node->next;
      if (mn_node->next != nullptr)
        mn_node->next->prev = mn_node->prev;
      sm = max(sm, mn * time[0]);
    }
  }
  cout << sm;
}
