#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <unordered_map>
#include <queue>
#include <iomanip>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';


struct patron 
{
    lli x, t;
};

struct st
{
    lli l, ind, r;
};

vector<patron> v;
vector<st> g;
lli n;

bool cmp(st s1, st s2)
{
    return s1.l < s2.l;
}

bool check(lli maxtime)
{
    g.clear();
    priority_queue<pair<lli,lli>, vector<pair<lli, lli>>, greater<pair<lli,lli>>> pq;
    for (int i = 1; i <= n; i++) {
        lli dist = maxtime / v[i].t;
        g.push_back({ max(1LL,v[i].x - dist), i ,min(n,v[i].x+dist)});
    }
    sort(g.begin(), g.end(), cmp);

    lli gind = 0;
    for (int i = 1; i <= n; i++) {
        while (gind < n && g[gind].l == i)pq.push({ g[gind].r,g[gind++].ind });
        if (pq.empty())return false;
        pair<lli, lli> a = pq.top();
        pq.pop();
        if (a.first < i)return false;
    }
    return true;
}

void solve()
{
    cin >> n;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> v[i].x >> v[i].t;
    }

    lli l = 0, r = 5;
    while (l < r) {
        lli m = (l + r) / 2;
        if (check(m))r = m;
        else l = m + 1;
    }
    cout << l;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

