#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <unordered_map>
#include <queue>
#include <iomanip>
#include <numeric>
#include <set>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';


struct rect
{
    lli l, r, h, c;
};



vector<rect> v;
vector<pair<lli, lli>> dp;
vector<lli> best1;
vector<lli> best2;
vector<lli> ps;
vector<lli> pslr;
set<lli> best501;
set<lli> best502;

lli func1(lli ind, lli l)
{
    lli res = dp[l - 1].second;

    lli opt = 0;
    lli p = v[ind].l;
    for (int i = ind - 1; i >= l; i--) {
        opt -= v[i].c * (p - v[i].r);
        p -= (v[i].r - v[i].l);
        opt += min(v[i].h, v[i + 1].h) * 2;
    }
    return res + opt;
}

lli func2(lli r, lli ind)
{
    lli res = dp[ind].first;
    lli opt = 0;
    lli p = v[ind].r;
    for (int i = ind + 1; i <= r; i++) {
        opt -= v[i].c * (v[i].l - p);
        p += (v[i].r - v[i].l);
        opt += min(v[i].h, v[i - 1].h) * 2;
    }
    return res + opt;

}

lli func3(lli ind, lli l)
{
    if (ind == l)return  dp[l - 1].second;;
    lli res = dp[l - 1].second;

    lli opt = best1[l];
    lli sd = ps[ind - 1] - ps[l - 1];
    opt -= sd * (v[ind].l - v[ind - 1].r);
    opt += min(v[ind - 1].h, v[ind].h) * 2;
    best1[l] = opt;
    return res + opt;
}

lli func4(lli ind, lli l)
{
    lli res = dp[l].first;

    lli opt = best2[l];
    opt += min(v[ind].h, v[ind - 1].h) * 2;
    lli ds = pslr[ind - 1] - pslr[l];
    opt -= (v[ind].l - v[l].r - ds) * v[ind].c;
    best2[l] = opt;
    return res + opt;

}


lli ts1(lli i)
{
    lli l = 1, r = i;
    while (l < r) {
        lli m1 = l + (r - l) / 3;
        lli m2 = r - (r - l) / 3;
        lli val1 = func1(i, m1);
        lli val2 = func1(i, m2);
        if (val1 > val2)r = m2 - 1;
        else l = m1 + 1;
    }
    return l;
}

lli ts2(lli i)
{
    lli l = 1, r = i - 1;
    while (l < r) {
        lli m1 = l + (r - l) / 3;
        lli m2 = r - (r - l) / 3;
        lli val1 = func2(i, m1);
        lli val2 = func2(i, m2);
        if (val1 > val2)r = m2 - 1;
        else l = m1 + 1;
    }
    return l;
}


lli perebor1(lli i)
{
    lli res = -1;
    lli k = 1;
    best501.insert(i);
    lli minn = 1e18;
    lli del = 0;
    for (auto l : best501) {
        lli tres = func3(i, l);
        //       cout << tres << " ";
        if (tres > res) {
            k = l;
            res = tres;
        }
        if (tres < minn) {
            minn = tres;
            del = l;
        }
    }
    if (best501.size() > 100)best501.erase(del);
    //   cout << LF;
    return k;
}

lli perebor2(lli i)
{
    lli res = -1;
    lli k = 1;
    lli del = 0;
    lli minn = 1e18;
    for (auto l : best502) {
        lli tres = func4(i, l);
        if (tres > res) {
            k = l;
            res = tres;
        }
        if (tres < minn) {
            minn = tres;
            del = l;
        }
    }
    if (best502.size() > 100)best502.erase(del);
    best502.insert(i);
    return k;
}


void czero(lli n, lli m)
{
    lli ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += abs(v[i].h - v[i - 1].h);
    }
    ans += v[n].h + m;
    cout << ans;
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    v.resize(n + 1);
    lli tans = m;
    ps.resize(n + 1);
    pslr.resize(n + 1);
    lli maxc = 0;
    for (int i = 1; i <= n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].h >> v[i].c;
        tans += v[i].h * 2;
        ps[i] = ps[i - 1] + v[i].c;
        pslr[i] = pslr[i - 1] + v[i].r - v[i].l;
        maxc = max(maxc, v[i].c);
    }
    if (maxc == 0) {
        czero(n, m);
        return;
    }

    dp.resize(n + 1);
    dp[1] = { 0,0 };
    best1.resize(n + 1, 0);
    best2.resize(n + 1, 0);
    best501.insert(1);
    best502.insert(1);
    for (int i = 2; i <= n; i++) {
        //lli x;
        //if (i>5000)x = ts1(i);
        //else x = perebor1(i);
        lli x = perebor1(i);
        dp[i].first = func1(i, x);

        //lli x2;
        //if (i>5000)x2 = ts2(i);
        //else x2 = perebor2(i);
        lli x2 = perebor2(i);
        dp[i].second = max(dp[i].first, func2(i, x2));
    }
    cout << tans - dp[n].second;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

