#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct pereshkoda {
    ll l, r, h, c;
};
struct change {
    ll win, ind1, ind2;
    bool pered;
};

bool comp2(pereshkoda a, pereshkoda b) {
    return a.l < b.l;
}

void ans(ll n, vector<change>& win, vector<pereshkoda>& a) {
    for (ll i = 1; i < n; i++) {
        if (a[i - 1].c < a[i].c) {
            win[i - 1].win = min(a[i - 1].h*2, a[i].h*2) - a[i - 1].c * (a[i].l - a[i - 1].r);
            win[i - 1].ind1 = i - 1;
            win[i - 1].ind2 = i;
            win[i - 1].pered = false;
        }
        else {
            win[i - 1].win = min(a[i - 1].h*2, a[i].h*2) - a[i].c * (a[i].l - a[i - 1].r);
            win[i - 1].ind1 = i - 1;
            win[i - 1].ind2 = i;
            win[i - 1].pered = true;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n, m, time, maxh = 0;
    cin >> n >> m;
    time = m;
    vector<pereshkoda> a(n);
    vector<change> win(n);
    change maxwin;
    bool ab = false;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r >> a[i].h >> a[i].c;
        if (a[i].h > maxh) {
            maxh = a[i].h;
        }
        if (a[i].c == 0) {
            ab = true;
        }
    }
    if (ab) {
        time += maxh;
    }
    else {
        for (ll i = 0; i < a.size(); i++) {
            time += a[i].h * 2;
        }
    }
    cout << time << '\n';
}
